/*
**
** Linux local kernel module, kernel overwrite.
**
*/

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/fs.h>
#include "dummy.h"

MODULE_LICENSE("GPL");
MODULE_AUTHOR("/dev/null");
MODULE_DESCRIPTION("Dummy module.");

int dummy_ioctl(struct inode *inode,
		struct file *file,
		unsigned int num,
		unsigned long param)
{
    dummy_t *dummy;

    printk("dummy_ioctl(%p, %p, %u, %lu)", inode, file, num, param);
    (*dummy->dest) = dummy->source;
    return 0;
}

/** All file operations for /dev/nulldummy. */
struct file_operations dummy_ops = {
    .ioctl = dummy_ioctl,
};

int dummy_init(void)
{
    int ret;

    printk(KERN_INFO "dummy_init()\n");

    /* Register our dummy device. */
    if((ret = register_chrdev(DUMMY_MAJOR, DUMMY_DEVICE, &dummy_ops)) < 0)
    {
	printk(KERN_ALERT "failed to register dummy device (major=%d,dev=%s)\n",
	    DUMMY_MAJOR, DUMMY_DEVICE);
	return ret;
    }
    printk(KERN_INFO "dummy character device created (major=%d,dev=%s)\n",
	DUMMY_MAJOR, DUMMY_DEVICE);

    return 0;
}

void dummy_exit(void)
{
    printk(KERN_INFO "dummy_exit()\n");
    
    if(unregister_chrdev(DUMMY_MAJOR, DUMMY_DEVICE) < 0)
	printk(KERN_ALERT "failed to unregister dummy device (major=%d,dev=%s)\n",
	    DUMMY_MAJOR, DUMMY_DEVICE);
}

module_init(dummy_init);
module_exit(dummy_exit);
